#include <glib-object.h>
#include <dbus/dbus-glib.h>
#include <telepathy-glib/dbus-properties-mixin.h>

G_BEGIN_DECLS

/**
 * EmpSvcChannelHandler:
 *
 * Dummy typedef representing any implementation of this interface.
 */
typedef struct _EmpSvcChannelHandler EmpSvcChannelHandler;

/**
 * EmpSvcChannelHandlerClass:
 *
 * The class of EmpSvcChannelHandler.
 */
typedef struct _EmpSvcChannelHandlerClass EmpSvcChannelHandlerClass;

GType emp_svc_channel_handler_get_type (void);
#define EMP_TYPE_SVC_CHANNEL_HANDLER \
  (emp_svc_channel_handler_get_type ())
#define EMP_SVC_CHANNEL_HANDLER(obj) \
  (G_TYPE_CHECK_INSTANCE_CAST((obj), EMP_TYPE_SVC_CHANNEL_HANDLER, EmpSvcChannelHandler))
#define EMP_IS_SVC_CHANNEL_HANDLER(obj) \
  (G_TYPE_CHECK_INSTANCE_TYPE((obj), EMP_TYPE_SVC_CHANNEL_HANDLER))
#define EMP_SVC_CHANNEL_HANDLER_GET_CLASS(obj) \
  (G_TYPE_INSTANCE_GET_INTERFACE((obj), EMP_TYPE_SVC_CHANNEL_HANDLER, EmpSvcChannelHandlerClass))


typedef void (*emp_svc_channel_handler_handle_channel_impl) (EmpSvcChannelHandler *self,
    const gchar *in_Bus_Name,
    const gchar *in_Connection,
    const gchar *in_Channel_Type,
    const gchar *in_Channel,
    guint in_Handle_Type,
    guint in_Handle,
    DBusGMethodInvocation *context);
void emp_svc_channel_handler_implement_handle_channel (EmpSvcChannelHandlerClass *klass, emp_svc_channel_handler_handle_channel_impl impl);
/**
 * emp_svc_channel_handler_return_from_handle_channel:
 * @context: The D-Bus method invocation context
 *
 * Return successfully by calling dbus_g_method_return().
 * This inline function exists only to provide type-safety.
 */
static inline
/* this comment is to stop gtkdoc realising this is static */
void emp_svc_channel_handler_return_from_handle_channel (DBusGMethodInvocation *context);
static inline void
emp_svc_channel_handler_return_from_handle_channel (DBusGMethodInvocation *context)
{
  dbus_g_method_return (context);
}


/**
 * EmpSvcStreamEngine:
 *
 * Dummy typedef representing any implementation of this interface.
 */
typedef struct _EmpSvcStreamEngine EmpSvcStreamEngine;

/**
 * EmpSvcStreamEngineClass:
 *
 * The class of EmpSvcStreamEngine.
 */
typedef struct _EmpSvcStreamEngineClass EmpSvcStreamEngineClass;

GType emp_svc_stream_engine_get_type (void);
#define EMP_TYPE_SVC_STREAM_ENGINE \
  (emp_svc_stream_engine_get_type ())
#define EMP_SVC_STREAM_ENGINE(obj) \
  (G_TYPE_CHECK_INSTANCE_CAST((obj), EMP_TYPE_SVC_STREAM_ENGINE, EmpSvcStreamEngine))
#define EMP_IS_SVC_STREAM_ENGINE(obj) \
  (G_TYPE_CHECK_INSTANCE_TYPE((obj), EMP_TYPE_SVC_STREAM_ENGINE))
#define EMP_SVC_STREAM_ENGINE_GET_CLASS(obj) \
  (G_TYPE_INSTANCE_GET_INTERFACE((obj), EMP_TYPE_SVC_STREAM_ENGINE, EmpSvcStreamEngineClass))


typedef void (*emp_svc_stream_engine_set_output_volume_impl) (EmpSvcStreamEngine *self,
    const gchar *in_channel_path,
    guint in_stream_id,
    guint in_volume,
    DBusGMethodInvocation *context);
void emp_svc_stream_engine_implement_set_output_volume (EmpSvcStreamEngineClass *klass, emp_svc_stream_engine_set_output_volume_impl impl);
/**
 * emp_svc_stream_engine_return_from_set_output_volume:
 * @context: The D-Bus method invocation context
 *
 * Return successfully by calling dbus_g_method_return().
 * This inline function exists only to provide type-safety.
 */
static inline
/* this comment is to stop gtkdoc realising this is static */
void emp_svc_stream_engine_return_from_set_output_volume (DBusGMethodInvocation *context);
static inline void
emp_svc_stream_engine_return_from_set_output_volume (DBusGMethodInvocation *context)
{
  dbus_g_method_return (context);
}

typedef void (*emp_svc_stream_engine_mute_input_impl) (EmpSvcStreamEngine *self,
    const gchar *in_channel_path,
    guint in_stream_id,
    gboolean in_mute_state,
    DBusGMethodInvocation *context);
void emp_svc_stream_engine_implement_mute_input (EmpSvcStreamEngineClass *klass, emp_svc_stream_engine_mute_input_impl impl);
/**
 * emp_svc_stream_engine_return_from_mute_input:
 * @context: The D-Bus method invocation context
 *
 * Return successfully by calling dbus_g_method_return().
 * This inline function exists only to provide type-safety.
 */
static inline
/* this comment is to stop gtkdoc realising this is static */
void emp_svc_stream_engine_return_from_mute_input (DBusGMethodInvocation *context);
static inline void
emp_svc_stream_engine_return_from_mute_input (DBusGMethodInvocation *context)
{
  dbus_g_method_return (context);
}

typedef void (*emp_svc_stream_engine_mute_output_impl) (EmpSvcStreamEngine *self,
    const gchar *in_channel_path,
    guint in_stream_id,
    gboolean in_mute_state,
    DBusGMethodInvocation *context);
void emp_svc_stream_engine_implement_mute_output (EmpSvcStreamEngineClass *klass, emp_svc_stream_engine_mute_output_impl impl);
/**
 * emp_svc_stream_engine_return_from_mute_output:
 * @context: The D-Bus method invocation context
 *
 * Return successfully by calling dbus_g_method_return().
 * This inline function exists only to provide type-safety.
 */
static inline
/* this comment is to stop gtkdoc realising this is static */
void emp_svc_stream_engine_return_from_mute_output (DBusGMethodInvocation *context);
static inline void
emp_svc_stream_engine_return_from_mute_output (DBusGMethodInvocation *context)
{
  dbus_g_method_return (context);
}

typedef void (*emp_svc_stream_engine_set_output_window_impl) (EmpSvcStreamEngine *self,
    const gchar *in_channel_path,
    guint in_stream_id,
    guint in_window,
    DBusGMethodInvocation *context);
void emp_svc_stream_engine_implement_set_output_window (EmpSvcStreamEngineClass *klass, emp_svc_stream_engine_set_output_window_impl impl);
/**
 * emp_svc_stream_engine_return_from_set_output_window:
 * @context: The D-Bus method invocation context
 *
 * Return successfully by calling dbus_g_method_return().
 * This inline function exists only to provide type-safety.
 */
static inline
/* this comment is to stop gtkdoc realising this is static */
void emp_svc_stream_engine_return_from_set_output_window (DBusGMethodInvocation *context);
static inline void
emp_svc_stream_engine_return_from_set_output_window (DBusGMethodInvocation *context)
{
  dbus_g_method_return (context);
}

typedef void (*emp_svc_stream_engine_add_preview_window_impl) (EmpSvcStreamEngine *self,
    guint in_window,
    DBusGMethodInvocation *context);
void emp_svc_stream_engine_implement_add_preview_window (EmpSvcStreamEngineClass *klass, emp_svc_stream_engine_add_preview_window_impl impl);
/**
 * emp_svc_stream_engine_return_from_add_preview_window:
 * @context: The D-Bus method invocation context
 *
 * Return successfully by calling dbus_g_method_return().
 * This inline function exists only to provide type-safety.
 */
static inline
/* this comment is to stop gtkdoc realising this is static */
void emp_svc_stream_engine_return_from_add_preview_window (DBusGMethodInvocation *context);
static inline void
emp_svc_stream_engine_return_from_add_preview_window (DBusGMethodInvocation *context)
{
  dbus_g_method_return (context);
}

typedef void (*emp_svc_stream_engine_remove_preview_window_impl) (EmpSvcStreamEngine *self,
    guint in_window,
    DBusGMethodInvocation *context);
void emp_svc_stream_engine_implement_remove_preview_window (EmpSvcStreamEngineClass *klass, emp_svc_stream_engine_remove_preview_window_impl impl);
/**
 * emp_svc_stream_engine_return_from_remove_preview_window:
 * @context: The D-Bus method invocation context
 *
 * Return successfully by calling dbus_g_method_return().
 * This inline function exists only to provide type-safety.
 */
static inline
/* this comment is to stop gtkdoc realising this is static */
void emp_svc_stream_engine_return_from_remove_preview_window (DBusGMethodInvocation *context);
static inline void
emp_svc_stream_engine_return_from_remove_preview_window (DBusGMethodInvocation *context)
{
  dbus_g_method_return (context);
}

typedef void (*emp_svc_stream_engine_shutdown_impl) (EmpSvcStreamEngine *self,
    DBusGMethodInvocation *context);
void emp_svc_stream_engine_implement_shutdown (EmpSvcStreamEngineClass *klass, emp_svc_stream_engine_shutdown_impl impl);
/**
 * emp_svc_stream_engine_return_from_shutdown:
 * @context: The D-Bus method invocation context
 *
 * Return successfully by calling dbus_g_method_return().
 * This inline function exists only to provide type-safety.
 */
static inline
/* this comment is to stop gtkdoc realising this is static */
void emp_svc_stream_engine_return_from_shutdown (DBusGMethodInvocation *context);
static inline void
emp_svc_stream_engine_return_from_shutdown (DBusGMethodInvocation *context)
{
  dbus_g_method_return (context);
}

void emp_svc_stream_engine_emit_receiving (gpointer instance,
    const gchar *arg_channel_path,
    guint arg_stream_id,
    gboolean arg_state);
void emp_svc_stream_engine_emit_stream_state_changed (gpointer instance,
    const gchar *arg_channel_path,
    guint arg_stream_id,
    guint arg_state,
    guint arg_direction);

/**
 * EmpSvcTubeHandler:
 *
 * Dummy typedef representing any implementation of this interface.
 */
typedef struct _EmpSvcTubeHandler EmpSvcTubeHandler;

/**
 * EmpSvcTubeHandlerClass:
 *
 * The class of EmpSvcTubeHandler.
 */
typedef struct _EmpSvcTubeHandlerClass EmpSvcTubeHandlerClass;

GType emp_svc_tube_handler_get_type (void);
#define EMP_TYPE_SVC_TUBE_HANDLER \
  (emp_svc_tube_handler_get_type ())
#define EMP_SVC_TUBE_HANDLER(obj) \
  (G_TYPE_CHECK_INSTANCE_CAST((obj), EMP_TYPE_SVC_TUBE_HANDLER, EmpSvcTubeHandler))
#define EMP_IS_SVC_TUBE_HANDLER(obj) \
  (G_TYPE_CHECK_INSTANCE_TYPE((obj), EMP_TYPE_SVC_TUBE_HANDLER))
#define EMP_SVC_TUBE_HANDLER_GET_CLASS(obj) \
  (G_TYPE_INSTANCE_GET_INTERFACE((obj), EMP_TYPE_SVC_TUBE_HANDLER, EmpSvcTubeHandlerClass))


typedef void (*emp_svc_tube_handler_handle_tube_impl) (EmpSvcTubeHandler *self,
    const gchar *in_Bus_Name,
    const gchar *in_Connection,
    const gchar *in_Channel,
    guint in_Handle_Type,
    guint in_Handle,
    guint in_id,
    DBusGMethodInvocation *context);
void emp_svc_tube_handler_implement_handle_tube (EmpSvcTubeHandlerClass *klass, emp_svc_tube_handler_handle_tube_impl impl);
/**
 * emp_svc_tube_handler_return_from_handle_tube:
 * @context: The D-Bus method invocation context
 *
 * Return successfully by calling dbus_g_method_return().
 * This inline function exists only to provide type-safety.
 */
static inline
/* this comment is to stop gtkdoc realising this is static */
void emp_svc_tube_handler_return_from_handle_tube (DBusGMethodInvocation *context);
static inline void
emp_svc_tube_handler_return_from_handle_tube (DBusGMethodInvocation *context)
{
  dbus_g_method_return (context);
}



G_END_DECLS
